﻿//////////////////////////////////////////////
// Effect.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class Shader ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../Dll/DllDefines.h"

#include "EffectType.h"

// nkMemory
#include <NilkinsMemory/Containers/String.h>
#include <NilkinsMemory/Containers/StringView.h>

/// Class ------------------------------------

namespace nkAstraeus
{
	class DLL_ASTRAEUS_EXPORT Effect
	{
		protected :

			// Attributes
			// Name for identification
			nkMemory::String _name ;

			// Final shader that will be held by the material, populated by child class
			nkGraphics::Shader* _shader ;

		protected :

			// Functions
			// Name compilation
			nkMemory::String _getShaderName () const ;

		public :

			// Constructor, destructor
			Effect () ;
			virtual ~Effect () ;

			// Getters
			nkMemory::StringView getName () const ;
			nkGraphics::Shader* getShader () const ;
			virtual EFFECT_TYPE getType () const = 0 ;

			// Setters
			void setName (const nkMemory::StringView& value) ;

			// Load
			virtual bool load () = 0 ;
			virtual void unload () = 0 ;
	} ;
}