﻿//////////////////////////////////////////////
// EffectManager.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkAstraeus
{
	class Effect ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../Dll/DllDefines.h"

#include "EffectType.h"

// nkCommon
#include <nilkinsCommon/Patterns/SingletonClass.h>

// nkMemory
#include <NilkinsMemory/Containers/StringView.h>

// Standards
#include <string>
#include <unordered_map>

/// Class ------------------------------------

namespace nkAstraeus
{
	class DLL_ASTRAEUS_EXPORT EffectManager final : public nkCommon::SingletonClass<EffectManager>
	{
		friend class nkCommon::SingletonClass<EffectManager> ;

		private :

			// Attributes
			// Memory
			std::unordered_map<std::string, Effect*> _effects ;

		private :

			// Functions
			// Constructor, destructor
			EffectManager () ;
			~EffectManager () ;

		public :

			// Management
			Effect* createOrRetrieve (const nkMemory::StringView& name, EFFECT_TYPE type) ;
			Effect* get (const nkMemory::StringView& name) ;
			Effect* getByIndex (unsigned int id) ;
			void rename (const nkMemory::StringView& currentName, const nkMemory::StringView& newName) ;
			void erase (const nkMemory::StringView& name) ;
	} ;
}