﻿//////////////////////////////////////////////
// Window.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

typedef struct HWND__* HWND ;

namespace nkImages
{
	class ImageView ;
}

namespace nkWinUi
{
	class MenuBar ;
}

/// Includes ---------------------------------

// nkWinUi
#include "../Dll/DllDefines.h"

#include "../Inputs/CallbackRepository.h"

#include "Component.h"

/// Class ------------------------------------
	
namespace nkWinUi
{
	class DLL_WINUI_EXPORT Window : public Component
	{
		protected :

			// Attributes
			// Callbacks
			mouseClickCallback _clickCallback ;
			closeCallback _closeCallback ;
			mouseLeaveCallback _mouseLeaveCallback ;
			resizeCallback _resizeCallback ;

			// Flags
			bool _noBorder ;

		public :
		
			// Constructor, destructor
			Window () ;
			~Window () ;

			// Getters
			virtual bool isMaximized () const ;
			virtual bool isFullscreen () const ;
			virtual HWND getHwnd () const ;
			virtual nkMemory::String getCanvasId () const ;

			// Setters
			void setClickCallback (const mouseClickCallback& value) ;
			void setCloseCallback (const closeCallback& callback) ;
			void setMouseLeaveCallback (const mouseLeaveCallback& callback) ;
			void setResizeCallback (const resizeCallback& callback) ;
			void setNoBorder (bool value) ;
			virtual void setIcon (const nkImages::ImageView& icon) = 0 ;

			// Size
			virtual void maximize (bool val, bool coverTaskBar = false) = 0 ;

			// Import / Export
			virtual void exportIntrospection (nkExport::Node* rootNode) override ;
			virtual void importClassFromTree (nkExport::Node* rootNode) override ;
	} ;
}